<?php

namespace app\admin\controller;

use app\common\controller\Backend;
use app\common\model\News as NewsModel;
use fast\Tree;
use think\Db;

/**
 * 分类管理
 *
 * @icon   fa fa-list
 * @remark 用于管理网站的所有分类,分类可进行无限级分类,分类类型请在常规管理->系统配置->字典配置中添加
 */
class News extends Backend
{

    /**
     * @var \app\common\model\News
     */
    protected $model = null;
    protected $Newslist = [];
    protected $noNeedRight = ['selectpage'];

    public function _initialize()
    {
        parent::_initialize();
        // $this->model = model('app\common\model\News');

        // $tree = Tree::instance();
        // $tree->init(collection($this->model->order('weigh desc,id desc')->select())->toArray(), 'pid');
        // $this->Newslist = $tree->getTreeList($tree->getTreeArray(0), 'name');
        // $Newsdata = [0 => ['type' => 'all', 'name' => __('None')]];
        // foreach ($this->Newslist as $k => $v) {
        //     $Newsdata[$v['id']] = $v;
        // }
        // $typeList = NewsModel::getTypeList();
        // $this->view->assign("flagList", $this->model->getFlagList());
        // $this->view->assign("typeList", $typeList);
        // // $this->view->assign("parentList", $Newsdata);
        // $this->assignconfig('typeList', $typeList);
    }

    /**
     * 查看文章列表
     */
    public function index()
    {
        //设置过滤方法
        $this->request->filter(['strip_tags']);
        if ($this->request->isAjax()) {
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }

            $offset = $this->request->request('offset');
            $limit = $this->request->request('limit');
            // var_dump($offset,$limit);die;

            $field = ['news_id','news_img','news_title','secondary_title','news_comtent','news_view','news_sort', 'FROM_UNIXTIME(news_createtime,"%Y-%m-%d %H-%m %s") as news_createtime'];
            $list =  Db::name('news')->field($field)->order('news_id desc')->limit($offset,$limit )->select();
            $result['total'] = Db::name('news')->count();
            $result['rows'] = $list;
            return json($result);
         }
         return $this->view->fetch();
    }


    /**
     * 添加
     */
    public function add()
    {
        if ($this->request->isPost()) {
            $this->token();
            // $news_title = $this->request->request()
            // var_dump("111",$news_title);die;
            $rowItem = [];

            $rowItem['news_img'] = $this->request->request('row.news_img');
            $rowItem['news_title'] = $this->request->request('row.news_title');
            $rowItem['secondary_title']=$this->request->request('row.secondary_title');
            $rowItem['news_comtent'] = $this->request->request('row.news_comtent');
            $rowItem['news_createtime'] = time();
            $rowItem['news_view'] = 0;
            $rowItem['news_sort'] = $this->request->request('row.news_sort');
            //var_dump("11",$rowItem);die;
            
            if($rowItem["news_img"] == ""){
                return ['code' => -1,'data'=>[],'msg' => '图片不能为空'];
            }
            if($rowItem["news_title"] == ""){
                return ['code' => -3,'data'=>[],'msg' => '标题不能为空'];
            }
            if($rowItem["secondary_title"] == ""){
                return ['code' => -4,'data'=>[],'msg' => '副标题不能为空'];
            }
            
            try {
                $res = Db::name('news')->insert($rowItem);
                if($res>0){
                    return ['code' => 1,'data'=>[],'msg' => '添加成功'];
                }else{
                    return ['code' => 0,'data'=>[],'msg' => '添加失败'];
                }
            } catch (Exception $e) {
                return ['code' => -5,'data'=>[],'msg' => '错误异常.'];
            }
        }

        return parent::add();
    }

    /**
     * 编辑
     */
    public function edit($ids = null)
    {   
        $need_field = ['news_id','news_img','news_title','news_comtent','news_view','news_sort','secondary_title', 'FROM_UNIXTIME(news_createtime,"%Y-%m-%d") as news_createtime'];
        $row =  Db::name('news')->field($need_field)->where('news_id',$ids)->select();
        if ($this->request->isPost()) {
            // var_dump("测试111");die;
            $this->token();
            $rowItem = [];
            $rowItem['news_img'] = $this->request->request('row.news_img');
            $rowItem['news_title'] = $this->request->request('row.news_title');
            $rowItem['secondary_title']=$this->request->request('row.secondary_title');
            $rowItem['news_comtent'] = $this->request->request('row.news_comtent');
            $rowItem['news_createtime'] = time();
            $rowItem['news_sort'] = $this->request->request('row.news_sort');
            //var_dump("11",$rowItem);die;
            
            if($rowItem["news_img"] == ""){
                return ['code' => -1,'data'=>[],'msg' => '图片不能为空'];
            }
            if($rowItem["news_title"] == ""){
                return ['code' => -3,'data'=>[],'msg' => '标题不能为空'];
            }
            if($rowItem["secondary_title"] == ""){
                return ['code' => -4,'data'=>[],'msg' => '副标题不能为空'];
            }
            
            try {
                $res = Db::name('news')->where('news_id', $ids)->update($rowItem);
                if($res>0){
                    return ['code' => 1,'data'=>[],'msg' => '修改成功'];
                }else{
                    return ['code' => 0,'data'=>[],'msg' => '添加失败'];
                }
            } catch (Exception $e) {
                return ['code' => -5,'data'=>[],'msg' => '错误异常.'];
            }
        }

        if(!$row){
            $row = [];
        }else{
            $row = $row[0];
        }
        $this->view->assign("row", $row);
        return $this->view->fetch();
    }


    /**
     * Selectpage搜索
     *
     * @internal
     */
    public function selectpage()
    {
        return parent::selectpage();
    }


    /***
     * 删除
     */
    public function del($ids=''){
        
        try {
            //code...
            $res = Db::name("news")->delete($ids);
            if($res>0){
                return ['code' => 1,'data'=>[],'msg' => '操作成功.'];
            }else{
                return ['code' => -1,'data'=>[],'msg' => '操作失败'];
            }
        } catch (\Throwable $th) {
            //throw $th;
            return ['code' => -2,'data'=>[],'msg' => '错误请求'];
        }
        
        
    }

   
}
